/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2025 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32f3xx_hal.h"

#include "stm32f3xx_ll_adc.h"
#include "stm32f3xx_ll_crc.h"
#include "stm32f3xx_ll_dac.h"
#include "stm32f3xx_ll_rcc.h"
#include "stm32f3xx_ll_bus.h"
#include "stm32f3xx_ll_system.h"
#include "stm32f3xx_ll_exti.h"
#include "stm32f3xx_ll_cortex.h"
#include "stm32f3xx_ll_utils.h"
#include "stm32f3xx_ll_pwr.h"
#include "stm32f3xx_ll_dma.h"
#include "stm32f3xx_ll_usart.h"
#include "stm32f3xx_ll_gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define KBDA2_RIGHT_Pin LL_GPIO_PIN_13
#define KBDA2_RIGHT_GPIO_Port GPIOC
#define SHR_CLK_Pin LL_GPIO_PIN_14
#define SHR_CLK_GPIO_Port GPIOC
#define SHR_STR_Pin LL_GPIO_PIN_15
#define SHR_STR_GPIO_Port GPIOC
#define XTAL_IN_Pin LL_GPIO_PIN_0
#define XTAL_IN_GPIO_Port GPIOF
#define XTAL_OUT_Pin LL_GPIO_PIN_1
#define XTAL_OUT_GPIO_Port GPIOF
#define KBDA1_LEFT_Pin LL_GPIO_PIN_0
#define KBDA1_LEFT_GPIO_Port GPIOC
#define KBDA1_RIGHT_Pin LL_GPIO_PIN_1
#define KBDA1_RIGHT_GPIO_Port GPIOC
#define ADC_JACK1_Pin LL_GPIO_PIN_2
#define ADC_JACK1_GPIO_Port GPIOC
#define ADC_JACK2_Pin LL_GPIO_PIN_3
#define ADC_JACK2_GPIO_Port GPIOC
#define HWRESET_Pin LL_GPIO_PIN_0
#define HWRESET_GPIO_Port GPIOA
#define USART2_TX_Pin LL_GPIO_PIN_2
#define USART2_TX_GPIO_Port GPIOA
#define DISP_BRIGHT_Pin LL_GPIO_PIN_4
#define DISP_BRIGHT_GPIO_Port GPIOA
#define KBDA2_DOWN_Pin LL_GPIO_PIN_6
#define KBDA2_DOWN_GPIO_Port GPIOA
#define KBDB1_LEFT_Pin LL_GPIO_PIN_7
#define KBDB1_LEFT_GPIO_Port GPIOA
#define KBDA1_UP_Pin LL_GPIO_PIN_4
#define KBDA1_UP_GPIO_Port GPIOC
#define KBDA1_DOWN_Pin LL_GPIO_PIN_5
#define KBDA1_DOWN_GPIO_Port GPIOC
#define KBDB1_UP_Pin LL_GPIO_PIN_0
#define KBDB1_UP_GPIO_Port GPIOB
#define KBDB1_DOWN_Pin LL_GPIO_PIN_1
#define KBDB1_DOWN_GPIO_Port GPIOB
#define KBDB2_LEFT_Pin LL_GPIO_PIN_2
#define KBDB2_LEFT_GPIO_Port GPIOB
#define KBDA2_LEFT_Pin LL_GPIO_PIN_8
#define KBDA2_LEFT_GPIO_Port GPIOC
#define KBDB2_DOWN_Pin LL_GPIO_PIN_9
#define KBDB2_DOWN_GPIO_Port GPIOA
#define I2S2_SDIN_Pin LL_GPIO_PIN_10
#define I2S2_SDIN_GPIO_Port GPIOA
#define KBDB1_RIGHT_Pin LL_GPIO_PIN_11
#define KBDB1_RIGHT_GPIO_Port GPIOA
#define KBDB2_RIGHT_Pin LL_GPIO_PIN_12
#define KBDB2_RIGHT_GPIO_Port GPIOA
#define SWDIO_Pin LL_GPIO_PIN_13
#define SWDIO_GPIO_Port GPIOA
#define SWCLK_Pin LL_GPIO_PIN_14
#define SWCLK_GPIO_Port GPIOA
#define KBDB2_UP_Pin LL_GPIO_PIN_11
#define KBDB2_UP_GPIO_Port GPIOC
#define TRACE_SWO_Pin LL_GPIO_PIN_3
#define TRACE_SWO_GPIO_Port GPIOB
#define SHR_DOUT_DISP_Pin LL_GPIO_PIN_8
#define SHR_DOUT_DISP_GPIO_Port GPIOB
#define SHR_DIN_KBD_Pin LL_GPIO_PIN_9
#define SHR_DIN_KBD_GPIO_Port GPIOB

/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
