# Nucleo-F303RE
_DigitalAudio485 prototype with STM32 Nucleo-F303RE board_

Initial state: STM32 Nucleo-F303RE board with factory settings

[[doc/images/NUCLEO-F303RE.jpg]]

## Board modification
[Nucleo Board manual (PDF)](https://www.st.com/resource/en/user_manual/um1724-stm32-nucleo64-boards-mb1136-stmicroelectronics.pdf)

### HSE oscillator from X3 crystal
_P.25 OSC clock supply_

* [ ] SB54 and SB55 OFF
* [ ] R35 and R37 soldered
* [ ] X3 crystal (8 MHz) soldered
* [ ] C33 and C34 soldered with 22 pF capacitors
* [ ] SB16 and SB50 OFF (MCO)

### Disable OSC 32kHz
_P.26 LSE not used_

* [ ] SB48 and SB49 ON
* [ ] R34 and R36 removed

### USB-Serial to UART5
_P.26 USART communication_

* [ ] SB62 and SB63 must be ON
* [ ] SB13 and SB14 must be OFF

## Development tools

[STM32 Cube IDE](https://www.st.com/en/development-tools/stm32cubeide.html)


